<script lang="ts">
import Vue from 'vue';
import SurveyHeader from './survey-header.vue';
import SurveyAccordion from './survey-accordion.vue';
import SurveyResultsRadio from './survey-results-radio.vue';
import SurveyBubbleTable from './survey-bubble-table.vue';
import SurveyCarousel from './survey-carousel.vue';
import SurveyTextResults from './survey-text-results.vue';
import { IsMobileMixin, toKebabCaseMixin } from '~/mixins';

export default Vue.extend({
  name: 'SurveySection',
  components: {
    SurveyHeader,
    SurveyAccordion,
    SurveyResultsRadio,
    SurveyBubbleTable,
    SurveyCarousel,
    SurveyTextResults,
  },
  mixins: [IsMobileMixin, toKebabCaseMixin],
  props: {
    data: {
      type: Object,
      required: true,
      default: () => {},
    },
  },
  computed: {
    leftDemoColumn() {
      return this.data.subsections[0].data.results.slice(0, 3);
    },
    rightDemoColumn() {
      return this.data.subsections[0].data.results.slice(3, 6);
    },
  },
  methods: {
    bubbleStyle(value, color) {
      const size = value * 2;
      return {
        width: `${size}px`,
        height: `${size}px`,
        lineHeight: `${size}px`,
        backgroundColor: color,
      };
    },
  },
});
</script>

<template>
  <section class="section" :class="data.demographics_section ? 'gradient' : ''">
    <SlpContainer>
      <div class="section__header">
        <div class="content-wrapper">
          <SlpTypography
            v-if="!data.demographics_section"
            :id="`${anchorID(data.title)}-label`"
            tag="p"
            class="label"
            >{{ data.mobile_subtitle }}</SlpTypography
          >
          <SlpTypography
            :id="`${anchorID(data.title)}`"
            tag="h2"
            :data-aos="data.demographics_section ? 'fade-up' : ''"
            :data-aos-duration="500"
            :variant="
              data.demographics_section ? 'heading1-bold' : 'heading2-bold'
            "
            :arial-labelledby="`${anchorID(data.title)}-label`"
            >{{ data.title }}
          </SlpTypography>
          <SlpTypography
            tag="div"
            variant="body2"
            class="slp-mt-8 subsection-text"
          >
            <div v-html="$md.render(data.text)" />
          </SlpTypography>
        </div>
        <div
          v-if="data.img_src && !data.demographics_section"
          class="image-wrapper"
        >
          <nuxt-img
            :src="data.img_src"
            alt=""
            data-aos="fade-up"
            :data-aos-duration="500"
          />
        </div>
        <div
          v-if="data.img_src && data.demographics_section"
          class="image-wrapper demographics"
        >
          <nuxt-img
            :src="data.img_src"
            alt=""
            data-aos="fade-left"
            :data-aos-duration="500"
          />
        </div>
      </div>
      <div
        v-for="subsection in data.subsections"
        :key="subsection.subheader"
        class="subsection"
      >
        <div v-if="subsection.subtext" class="subsection__header">
          <SurveyHeader
            :header="data.label"
            :text="subsection.subtext"
            :img-variant="subsection.img_variant"
          />
        </div>
        <div
          class="subsection__content"
          :class="subsection.inverse ? 'inverse' : ''"
        >
          <div
            class="report"
            v-bind="
              !isMobile
                ? {
                    'data-aos': subsection.inverse ? 'fade-left' : 'fade-right',
                    'data-aos-duration': '700',
                    'data-aos-offset': '100',
                  }
                : {}
            "
          >
            <!-- Radio / filter controls -->
            <SurveyAccordion
              v-if="subsection.data && subsection.data.type === 'radio'"
              :data="subsection.data.results_label"
              background-color="#F6F3FE"
              :open-by-default="isMobile"
            >
              <SurveyCarousel
                v-if="subsection.data.results.length > 1"
                controls-on-top
                :data="subsection.data.carousel"
                :components="{
                  type: 'SurveyResultsRadio',
                  data: subsection.data.results,
                }"
              />

              <SurveyResultsRadio v-else :data="subsection.data.results" />
            </SurveyAccordion>

            <!-- Bubble tables  -->
            <SurveyAccordion
              v-if="subsection.data && subsection.data.type === 'bubble_table'"
              :data="subsection.data.results_label"
              background-color="#F6F3FE"
              :open-by-default="isMobile"
              :mobile-only="data.demographics_section"
            >
              <SurveyCarousel
                v-if="subsection.data.results.length > 1"
                :data="subsection.data.carousel"
                controls-on-top
                :components="{
                  type: 'SurveyBubbleTable',
                  data: subsection.data.results,
                }"
              />

              <SurveyBubbleTable v-else :data="subsection.data.results" />
            </SurveyAccordion>

            <div
              v-if="data.demographics_section"
              class="demographics-results-desktop"
            >
              <div class="column">
                <SurveyBubbleTable
                  v-for="table in leftDemoColumn"
                  :key="table.header"
                  :data="table"
                  class="demographics-table"
                />
              </div>
              <div class="column">
                <SurveyBubbleTable
                  v-for="table in rightDemoColumn"
                  :key="table.header"
                  :data="table"
                  class="demographics-table"
                />
              </div>
            </div>

            <!-- Text-only Results -->
            <SurveyAccordion
              v-if="subsection.data && subsection.data.type === 'text_only'"
              :data="subsection.data.results_label"
              background-color="#F6F3FE"
              :open-by-default="isMobile"
            >
              <SurveyCarousel
                v-if="subsection.data.results.length > 1"
                :data="subsection.data.carousel"
                controls-on-top
                :components="{
                  type: 'SurveyTextResults',
                  data: subsection.data.results,
                }"
              />
              <SurveyTextResults v-else :data="subsection.data.results" />
            </SurveyAccordion>

            <!-- Handles that late addon instance of multiple component types within a carousel -->
            <SurveyAccordion
              v-if="subsection.data && subsection.data.type === 'multiple'"
              :data="subsection.data.results_label"
              background-color="#F6F3FE"
              :open-by-default="isMobile"
            >
              <SurveyCarousel
                :data="subsection.data.carousel"
                controls-on-top
                :components="{
                  data: subsection.data.results,
                }"
              />
            </SurveyAccordion>
          </div>

          <!-- Text blocks  -->
          <div
            v-if="subsection.text_blocks"
            class="text-blocks"
            v-bind="
              !isMobile
                ? {
                    'data-aos': subsection.inverse ? 'fade-right' : 'fade-left',
                    'data-aos-duration': '700',
                    'data-aos-offset': '100',
                  }
                : {}
            "
          >
            <div
              v-if="subsection.call_out_box"
              class="call-out-box"
              :class="subsection.call_out_box.stat ? 'flex' : ''"
            >
              <div>
                <p>{{ subsection.call_out_box.text }}</p>
              </div>
              <div
                v-if="subsection.call_out_box.stat"
                class="bubble"
                :style="
                  bubbleStyle(
                    subsection.call_out_box.stat.number,
                    subsection.call_out_box.stat.color,
                  )
                "
              >
                {{ subsection.call_out_box.stat.number }}%
              </div>
            </div>
            <SurveyAccordion
              v-for="(block, index) in subsection.text_blocks"
              :key="block.text"
              :class="`${subsection.mobile_only ? 'mobile-only' : ''}`"
              :data="{ title: block.title, text: block.text }"
              :is-desktop-accordion="subsection.text_blocks.length > 1"
              :open-by-default="
                !isMobile && subsection.text_blocks.length > 1 && index == 0
              "
            />
          </div>
        </div>
      </div>
    </SlpContainer>
  </section>
</template>

<style lang="scss" scoped>
.section {
  padding: 64px 0;
  position: relative;
  color: #232150;

  @media (max-width: $breakpoint-md) {
    padding: 16px 0 16px 0;
  }

  &.gradient {
    background: linear-gradient(0deg, #d7fefe 0.45%, #f2f1f5 99.68%);
    &:before {
      @media (min-width: $breakpoint-lg) {
        content: '';
        background: url('/nuxt-images/developer-survey/2024/2024-survey-hero-bg-pills.png');
        background-size: contain;
        background-repeat: no-repeat;
        position: absolute;
        top: -2%;
        left: 20%;
        z-index: 0;
        width: 3000px;
        height: 600px;
      }
    }

    .subsection-text {
      @media (max-width: $breakpoint-md) {
        display: none;
      }
    }

    .content-wrapper {
      h2 {
        display: block;
        margin-bottom: 24px;
      }
    }

    &:deep {
      .survey-accordion {
        @media (min-width: $breakpoint-md) {
          display: none;
        }
      }
    }

    .subsection__content {
      width: 100%;

      @media (min-width: $breakpoint-md) {
        display: block;
      }
    }
  }

  &__header {
    padding-top: 32px;
    color: #232150;
    position: relative;
    text-align: left;
    display: flex;
    align-items: flex-start;
    z-index: 5;

    @media (max-width: $breakpoint-md) {
      padding-bottom: 32px;
      flex-direction: column-reverse;
      gap: 32px;
      padding-top: 0;
    }

    .content-wrapper {
      flex: 0 0 60%;
      max-width: 600px;
      padding-right: 48px;

      @media (max-width: $breakpoint-md) {
        flex: 1 0 100%;
        padding-right: 0;
      }

      &:deep {
        font-size: 18px;

        ol,
        ul {
          padding-left: 1.25em;
        }

        li {
          margin-bottom: 8px;
          list-style-type: disc;
        }

        p {
          margin-bottom: 8px;
          display: block;
        }

        strong {
          font-weight: $font-weight-bold;
        }
      }
    }

    .image-wrapper:not(.demographics) {
      position: relative;
      flex: 1 0 40%;

      img {
        width: 100%;
        padding-left: 24px;

        @media (max-width: $breakpoint-md) {
          width: 100%;
          max-width: 100%;
          padding-left: 0;
        }
      }
    }

    .image-wrapper.demographics {
      img {
        width: 65%;
        z-index: -1;
        position: absolute;
        right: -8%;
        top: 14px;
      }

      @media (max-width: $breakpoint-md) {
        display: none;
      }
    }

    .label {
      font-size: 14px;
      font-weight: $font-weight-bold;
      line-height: 32px;
      margin-bottom: 8px;
    }
  }
}
.subsection {
  padding: 96px 0;

  @media (max-width: $breakpoint-md) {
    padding: 32px 0;
  }
  &__content {
    display: flex;
    flex-direction: row;
    gap: 32px;

    &.inverse {
      @media (min-width: $breakpoint-lg) {
        flex-direction: row-reverse;
      }
    }

    @media (max-width: $breakpoint-md) {
      flex-direction: column-reverse;
      gap: 8px;
    }

    .text-blocks,
    .report {
      width: 100%;
      flex: 0 1 50%;
    }

    .text-blocks {
      display: flex;
      flex-direction: column;
      gap: 8px;
    }
  }
}

.call-out-box {
  background: #f6f3fe;
  color: #232150;
  padding: 24px;
  font-size: 16px;
  border-radius: 8px;
  box-shadow: 0px 1px 4px 0px rgba(0, 0, 0, 0.1);
  margin-bottom: 8px;
  font-weight: $font-weight-bold;

  &.flex {
    display: flex;
    align-items: center;
  }

  .bubble {
    display: flex;
    align-items: center;
    justify-content: center;
    border-radius: 50%;
    color: #232150;
    font-family: 'GitLab Mono';
    text-align: center;
    font-size: 24px;
    flex: 0 0 25%;
    // transform: scale(0); Uncomment this once the intersection observer is set up
    transition: transform 0.8s ease-out;

    @media (prefers-reduced-motion: reduce) {
      transition: none;
    }

    @media (max-width: $breakpoint-md) {
      display: none;
    }
  }

  .bubble-visible {
    transform: scale(1);
  }
}

.demographics-results-desktop {
  display: flex;
  width: 100%;
  gap: 32px;
  @media (max-width: $breakpoint-md) {
    display: none;
  }

  .column {
    width: calc(50% - 32px);

    &:first-of-type {
      margin-top: 196px;
    }
  }

  .demographics-table {
    background: $color-surface-800;
    padding: 20px;
    color: #232150;
    border-radius: 8px;
    margin-bottom: 32px;
    box-shadow: 0px 1px 4px 0px rgba(0, 0, 0, 0.1);
  }
}

.mobile-only {
  @media (min-width: $breakpoint-lg) {
    display: none;
  }
}
</style>
